<?php

function ezin_admin_help_main() /* {{{ */
{
	global $ezin_sys, $ezin_cfg;
	
	$dir  = Platon::append_slash($ezin_sys['dir']['root']).'doc/';
	$d    = dir(Platon::str_replace_postfix('/', '', $dir));
	$file = Platon::parse_id_param('file');
	if (strpos($file, '/') !== false || strpos($file, '\\') !== false
			|| ! @file_exists($dir.$file) || @is_dir($dir.$file)) {
		$file = 'README';	
	}
	$suffix = array_reverse(explode('.', $file));
	$suffix = strtolower($suffix[0]);

	// Order in alphabetical order
	$listing = array();
	while (($entry = $d->read()) !== false) {
		array_push($listing, $entry);
	}
	sort($listing);
?>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="pme-main">
<tr><td width="100%" align="left" valign="top">
<b><?php echo htmlspecialchars($file); ?></b>
<hr class="pme-hr">
<?php

	ob_start();
	@readfile($dir.$file);
	$content = trim(ob_get_contents());
	ob_end_clean();

	if ($suffix == 'html') {
		$content = preg_replace('|<body[^>]*>(.*)</body>|si', '\\1', $content);
		echo $content;
	} else {
		$content = htmlspecialchars($content);
		$ezin_cfg['flags_admin'] = 'HWE';
		ezin_process_text_flags($content, 'admin');
		echo '<pre>', $content, '</pre>';
	}

?>
</td>
<td>&nbsp;</td>
<td nowrap="nowrap" align="left" valign="top">
<b>Documentation<br>Browser</b><hr class="pme-hr">
<?php

	for ($i = 0, $count = count($listing); $i < $count; $i++) {
		$entry = $listing[$i];
		if ($entry == '.' || $entry == '..' || @is_dir($dir.$entry)) {
			continue;
		}
		$entry = htmlspecialchars($entry);
		printf('<li><a href="%s?%s">%s</a></li>',
				htmlspecialchars($_SERVER['PHP_SELF']), $entry, $entry);
	}
?>
<hr class="pme-hr"><b><?php echo $count ?>&nbsp;files</b>
</td></tr>
</table>
<?php
} /* }}} */

ezin_admin_help_main();

/* Modeline for ViM {{{
 * vim: set ts=4:
 * vim600: fdm=marker fdl=0 fdc=0:
 * }}} */

?>
